function Overhead = P_SwtichVsAct( Act) %function of power overhead vs Activity

% We use two qudratic functions to model it
% part1_center = 0.01; % the center of a quadratic function
% part1_top_overhead = 0.01; %top overhead of switching in total act power
% 
% 
% part2_center = 0.5; % the center of a quadratic function
% part2_top_overhead = 0.001; % the top_overhead of switching in total act power
% 
% Overhead_part1 = part1_top_overhead -( Act - part1_center)^2 * part1_top_overhead/part1_center^2;
% Overhead_part2 = part2_top_overhead -( Act - part2_center)^2 * part2_top_overhead/part2_center^2;
% 
% P_overhead = (max(0, Overhead_part1) + max(0,Overhead_part2)) * ( Power-Leakage);
b = [765.635742007076,-4625.02305440147,4074.23711104204,11.0641373898008];

overhead_per_switch = 1000000*1e-9 / 8; %assume 20-60 cycles per switch, one cycle is 1ns, and 8s is the time of benchmark
Overhead = overhead_per_switch * ( b(1) * Act ^ 3 + b(2) * Act ^ 2 + b(3) * Act + b(4) );