% choose model for this stage
error_detect = 1;
for r_allocation = 1: length(devicemodel_allocation(:,1))
    if( length( find (devicemodel_allocation(r_allocation,:) == i_stage ) ) == 1 )
        subcktname = devicemodel(r_allocation).subcktname;
        error_detect = 0;
        break;
    end
end
if( error_detect)
    print('no model found for this bin stage');
    break;
end

pulse=5e9*Delay_i(i_stage);
clock1=10e9*Delay_i(i_stage);
fid=fopen(spname,'w');
fprintf(fid,'\n.inc ''%s'' \n',subcktname);
fprintf(fid,'.option converge=1 cptime=360\n');
fprintf(fid,'.param l=%d clock=%4.4fn cl=%d vd=%d vshift=%d rl=%d pulse=%4.4fn fanout=%3.2f ',L,clock1,C0,Xc(1,i_stage),Xc(2,i_stage),R,pulse,fanout-1); 
for i=1:n
    fprintf(fid,'w%i=%d ',i,Xc(2+i,i_stage));
end
fclose(fid);


write_derivation1;
fid=fopen(spname,'a');
fprintf(fid,'.subckt inv1 1 2 3 w=1u\nXn1 7 4 0 0 ntype Wid_ps=''2*w'' Len_ps=l\nXn2 2 8 7 0 ntype Wid_ps=''2*w'' Len_ps=l\nXp1 2 9 3 3 ptype Wid_ps=w Len_ps=l\nXp2 2 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 vshift\nVtp 5 1 ''-vshift'' \nVtno 8 3 vshift \nVtpo 9 3 ''-vshift''\n.ends\n');
fprintf(fid,'.subckt inv2 1 2 3 w=1u\nXn 6 4 0 0 ntype Wid_ps=w Len_ps=l\nXp 6 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 vshift\nVtp 5 1 ''-vshift'' \nRl 6 2 rl\nCl 2 0 cl\n.ends\n');

fprintf(fid,'xinv100 100 1 vdr inv2 w=w1\n');
 for i=1:1:n
     if(mod(i,2))
         fprintf(fid,'xinv%i %i %i vdd inv1 w=w%i\n',i,i,i+1,i);
     else
         fprintf(fid,'xinv%i %i %i vdd inv2 w=w%i\n',i,i,i+1,i);
         if(i<n)
             fprintf(fid,'xinv%i %i %i vdr inv1 w=''fanout*w%i''\n',100+i-1,i+1,200+i,i-1);
         else
             fprintf(fid,'xinv%i %i %i vdr inv1 w=''fanout*w%i+w%i''\n',100+i-1,i+1,200+i,i-1,i-1);
         end
%          fprintf(fid,'c%i %i 0 0.1fF\n',100+i-1,200+i);
     end
 end


if(flag_var)
    fprintf(fid,'.subckt inv1_s 1 2 3 dvt=0 w=1u\nXn1 7 4 0 0 ntype Wid_ps=''2*w'' Len_ps=l\nXn2 2 8 7 0 ntype Wid_ps=''2*w'' Len_ps=l\nXp1 2 9 3 3 ptype Wid_ps=w Len_ps=l\nXp2 2 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 ''dvt+vshift''\nVtp 5 1 ''-dvt-vshift'' \nVtno 8 3 ''dvt+vshift'' \nVtpo 9 3 ''-dvt-vshift''\n.ends\n');
    fprintf(fid,'.subckt inv2_s 1 2 3 dvt=0 w=1u\nXn 6 4 0 0 ntype Wid_ps=w Len_ps=l\nXp 6 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 ''dvt+vshift''\nVtp 5 1 ''-dvt-vshift'' \nRl 6 2 rl\nCl 2 0 cl\n.ends\n');

    fprintf(fid,'xinv100_s 100_s 1_s vdr_s inv2_s w=''w1-%4.4f'' dvt=%3.3f\n',dw1,dvt);
    for i=1:1:n
     if(mod(i,2))
         fprintf(fid,'xinv%i_s %i_s %i_s vdd_s inv1_s w=''w%i-%4.4f'' dvt=%3.3f\n',i,i,i+1,i,dw1,dvt);
     else
         fprintf(fid,'xinv%i_s %i_s %i_s vdd_s inv2_s w=''w%i-%4.4f'' dvt=%3.3f\n',i,i,i+1,i,dw1,dvt);
         if(i<n)
             fprintf(fid,'xinv%i_s %i_s %i_s vdr_s inv1_s w=''fanout*w%i-fanout*%4.4f'' dvt=%3.3f\n',100+i-1,i+1,200+i,i-1,dw1,dvt);
         else
             fprintf(fid,'xinv%i_s %i_s %i_S vdr_s inv1_s w=''fanout*w%i+w%i-%4.4f-fanout*%4.4f'' dvt=%3.3f\n',100+i-1,i+1,200+i,i-1,i-1,dw1,dw1,dvt);
         end
         
     end
    end
    
    fprintf(fid,'Vdr_s vdr_s 0 DC=''vd*%2.2f''\nVd_s vdd_s 0 DC=''vd*%2.2f''\nVpulse_s 100_s 0 PULSE(0,''vd*%2.2f'',10n,10p,10p,pulse,clock)\n',p_slow,p_slow,p_slow);
end



                 
fprintf(fid,'Vdr vdr 0 DC vd\nVd vdd 0 DC vd\nVpulse 100 0 PULSE(0,vd,10n,10p,10p,''pulse'',clock)\n.tran ''clock/100'' ''clock*3+10n'' sweep data=cv\n');
if(flag_var)
    fprintf(fid,'.measure tran t1 trig V(1_s) val=''%2.2f*vd/2'' TD=''10n+pulse*3/4'' rise=2 targ V(%i_s) val=''%2.2f*vd/2'' TD=''10n+pulse*3/4'' %s=2\n',p_slow,n+1,p_slow,edge);
else
    fprintf(fid,'.measure tran t1 trig V(1) val=''vd/2'' TD=''10n+pulse*3/4'' rise=2 targ V(%i) val=''vd/2'' TD=''10n+pulse*3/4'' %s=2\n',n+1,edge);   
end
fprintf(fid,'.measure tran dynamicpower avg par''p(Vd)+p(Vpulse)'' FROM=''clock*1.3+10n'' TO=''clock*2.3+10n''\n');
fprintf(fid,'.ic ');
fprintf(fid,'v(100)=0 ');
for i=1:n+1
    if(mod(i,2)==0)
        fprintf(fid,'v(%i)=0 ',i);
    else
        fprintf(fid,'v(%i)=''vd'' ',i);
    end
end
if(flag_var)
    fprintf(fid,'v(100_s)=0 ');
for i=1:n
    if(mod(i,2)==0)
        fprintf(fid,'v(%i_s)=0 ',i);
    else
        fprintf(fid,'v(%i_s)=''vd*%2.2f'' ',i,p_slow);
    end
end
end
fprintf(fid,'\n');
fprintf(fid,'.end');
fclose(fid);
unix(hspicerun);


    fid=fopen(resultname, 'r');
    
    
   
    if (fid ~= -1)
     x = [];
        for j=1:2+2+ceil(n/3)
         tline=fgetl(fid);
        end
        
        j=0;
        D=[];
        DE=[];
        D(1:n_partial)=-1;
        DE(1:n_partial)=-1;
        
        while(j<n_partial)
            j=j+1;
            tline = fgetl(fid);
            if(tline==-1)
                break;
            end
            [t r]=strtok(tline);
            [p,status]=str2num(t);
            if(status == 0)
                f2=1;
                break;
            else
                if( p<=0.99 || mod(p,1)~=0 )
                    f2=1;
                    break;
                end
            end
            
            for i=2:fix((n+2)/3)+1
                tline = fgetl(fid);
            end
            
            if(tline==-1)
                break;
            end
            [t r]=strtok(tline);
            for i=1:n+2-3*fix((n+2)/3)
                [t r]=strtok(r);
            end
            [x,status]=str2num(t);
            if(status==0)
                j=j-1;
                for i=1:ceil((n+6)/3)-ceil((n+3)/3)
                    tline = fgetl(fid);
                end
                continue;
%                 break;
            end
            D(p)=x;
                      
            if(n+2-3*fix((n+2)/3)<2)
                [t r]  = strtok(r);
            else
                tline=fgetl(fid);
                [t r] = strtok(tline);
            end
            [x,status]=str2num(t);
            if(status==0)
                j=j-1;
                for i=1:ceil((n+6)/3)-ceil((n+4)/3)
                    tline = fgetl(fid);
                end
                continue;
            end
            DE(p) = -x;
            
            for i=1:ceil((n+6)/3)-ceil((n+4)/3)
                tline = fgetl(fid);
            end
        end
        
        
        if(min(D)<0||min(DE)<0)
            f2=1;
        end
        
    else
        disp('cannot find delay power partial result');
    end
    fclose(fid);
    
    
    
    if(f2==1)
        fid=fopen(spname,'w');
        fprintf(fid,'\n.inc ''%s'' \n',subcktname);
        fprintf(fid,'.option converge=0 cptime=360\n');
        fprintf(fid,'.param l=%d clock=%4.4fn cl=%d vd=%d vshift=%d rl=%d pulse=%4.4fn fanout=%3.2f ',L,clock1,C0,Xc(1,i_stage),Xc(2,i_stage),R,pulse,fanout-1); 
        for i=1:n
            fprintf(fid,'w%i=%d ',i,Xc(2+i,i_stage));
        end


	fclose(fid);
        write_derivation2;
	fid=fopen(spname,'a');
        
    fprintf(fid,'.subckt inv1 1 2 3 w=1u\nXn1 7 4 0 0 ntype Wid_ps=''2*w'' Len_ps=l\nXn2 2 8 7 0 ntype Wid_ps=''2*w'' Len_ps=l\nXp1 2 9 3 3 ptype Wid_ps=w Len_ps=l\nXp2 2 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 vshift\nVtp 5 1 ''-vshift'' \nVtno 8 3 vshift \nVtpo 9 3 ''-vshift''\n.ends\n');
    fprintf(fid,'.subckt inv2 1 2 3 w=1u\nXn 6 4 0 0 ntype Wid_ps=w Len_ps=l\nXp 6 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 vshift\nVtp 5 1 ''-vshift'' \nRl 6 2 rl\nCl 2 0 cl\n.ends\n');
 
    fprintf(fid,'xinv100 100 1 vdr inv2 w=w1\n');
    for i=1:1:n
     if(mod(i,2))
         fprintf(fid,'xinv%i %i %i vdd inv1 w=w%i\n',i,i,i+1,i);
     else
         fprintf(fid,'xinv%i %i %i vdd inv2 w=w%i\n',i,i,i+1,i);
          if(i<n)
             fprintf(fid,'xinv%i %i %i vdr inv1 w=''fanout*w%i''\n',100+i-1,i+1,200+i,i-1);
         else
             fprintf(fid,'xinv%i %i %i vdr inv1 w=''fanout*w%i+w%i''\n',100+i-1,i+1,200+i,i-1,i-1);
          end
%          fprintf(fid,'c%i %i 0 0.1fF\n',100+i-1,200+i);
     end
    end
    
    if(flag_var)
        fprintf(fid,'.subckt inv1_s 1 2 3 dvt=0 w=1u\nXn1 7 4 0 0 ntype Wid_ps=''2*w'' Len_ps=l\nXn2 2 8 7 0 ntype Wid_ps=''2*w'' Len_ps=l\nXp1 2 9 3 3 ptype Wid_ps=w Len_ps=l\nXp2 2 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 ''dvt+vshift''\nVtp 5 1 ''-dvt-vshift'' \nVtno 8 3 ''dvt+vshift'' \nVtpo 9 3 ''-dvt-vshift''\n.ends\n');
        fprintf(fid,'.subckt inv2_s 1 2 3 dvt=0 w=1u\nXn 6 4 0 0 ntype Wid_ps=w Len_ps=l\nXp 6 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 ''dvt+vshift''\nVtp 5 1 ''-dvt-vshift'' \nRl 6 2 rl\nCl 2 0 cl\n.ends\n');

        fprintf(fid,'xinv100_s 100_s 1_s vdr_s inv2_s w=''w1-%4.4f'' dvt=%3.3f\n',dw1,dvt);
        for i=1:1:n
            if(mod(i,2))
                fprintf(fid,'xinv%i_s %i_s %i_s vdd_s inv1_s w=''w%i-%4.4f'' dvt=%3.3f\n',i,i,i+1,i,dw1,dvt);
            else
                fprintf(fid,'xinv%i_s %i_s %i_s vdd_s inv2_s w=''w%i-%4.4f'' dvt=%3.3f\n',i,i,i+1,i,dw1,dvt);
                if(i<n)
                    fprintf(fid,'xinv%i_s %i_s %i_s vdr_s inv1_s w=''fanout*w%i-fanout*%4.4f'' dvt=%3.3f\n',100+i-1,i+1,200+i,i-1,dw1,dvt);
                else
                    fprintf(fid,'xinv%i_s %i_s %i_S vdr_s inv1_s w=''fanout*w%i+w%i-%4.4f-fanout*%4.4f'' dvt=%3.3f\n',100+i-1,i+1,200+i,i-1,i-1,dw1,dw1,dvt);
                end
         
            end
        end
        fprintf(fid,'Vdr_s vdr_s 0 DC=''vd*%2.2f''\nVd_s vdd_s 0 DC=''vd*%2.2f''\nVpulse_s 100_s 0 PULSE(0,''vd*%2.2f'',10n,10p,10p,pulse,clock)\n',p_slow,p_slow,p_slow);
    end
                
        fprintf(fid,'Vdr vdr 0 DC vd\nVd vdd 0 DC vd\nVpulse 100 0 PULSE(0,vd,10n,10p,10p,pulse,clock)\n.tran ''clock/100'' ''clock*3+10n'' sweep data=cv\n');
        if(flag_var)
            fprintf(fid,'.measure tran t1 trig V(1_s) val=''%2.2f*vd/2'' TD=''10n+pulse*3/4'' rise=2 targ V(%i_s) val=''%2.2f*vd/2'' TD=''10n+pulse*3/4'' %s=2\n',p_slow,n+1,p_slow,edge);
        else
            fprintf(fid,'.measure tran t1 trig V(1) val=''vd/2'' TD=''10n+pulse*3/4'' rise=2 targ V(%i) val=''vd/2'' TD=''10n+pulse*3/4'' %s=2\n',n+1,edge);   
        end
        fprintf(fid,'.measure tran dynamicpower avg par''p(Vd)+p(Vpulse)'' FROM=''clock*1.3+10n'' TO=''clock*2.3+10n''\n');
        fprintf(fid,'.ic ');
        fprintf(fid,'v(100)=0 ');
        for i=1:n+1
            if(mod(i,2)==0)
                fprintf(fid,'v(%i)=0 ',i);
            else
                fprintf(fid,'v(%i)=''vd'' ',i);
            end
        end
        if(flag_var)
            fprintf(fid,'v(100_s)=0 ');
            for i=1:n
                if(mod(i,2)==0)
                    fprintf(fid,'v(%i_s)=0 ',i);
                else
                    fprintf(fid,'v(%i_s)=''vd*%2.2f'' ',i,p_slow);
                end
            end
        end
        fprintf(fid,'\n');
        fprintf(fid,'.end');
        fclose(fid);
        unix(hspicerun);


            fid=fopen(resultname, 'r');
            
    
   
            if (fid ~= -1)
                x = [];
                for j=1:2+2+ceil(n/3)
                    tline=fgetl(fid);
                end
                
                j=0;
        
                while(j<n_partial)
                    j=j+1;
                    tline = fgetl(fid);
                    if(tline==-1)
                        break;
                    end
                    [t r]=strtok(tline);
                    [p,status]=str2num(t);
                    if(status == 0)
                        f2=1;
                        break;

                    else
                        if( p<=0.99 || mod(p,1)~=0 )
                            f2=1;
                            break;
                        end

                    end
        
                    for i=2:fix((n+2)/3)+1
                        tline = fgetl(fid);
                    end
            
                    if(tline==-1)
                        break;
                    end
                    [t r]=strtok(tline);
                    for i=1:n+2-3*fix((n+2)/3)
                        [t r]=strtok(r);
                    end
                    [x,status]=str2num(t);
                    if(status==0)
                        j=j-1;
                        for i=1:ceil((n+6)/3)-ceil((n+3)/3)
                            tline = fgetl(fid);
                        end
                        continue;
                    end
                    if(x>0)
                        if(D(p)<0)
                            D(p)=x;
                        else
                            D(p)=(D(p)+x)/2;
                        end
                    end
                      
                    if(n+2-3*fix((n+2)/3)<2)
                        [t r]  = strtok(r);
                    else
                        tline=fgetl(fid);
                        [t r] = strtok(tline);
                    end
                    [x,status]=str2num(t);
                    if(status==0)
                        j=j-1;
                        for i=1:ceil((n+6)/3)-ceil((n+4)/3)
                        tline = fgetl(fid);
                        end
                    continue;
                    end
                    if(x<0)
                        if(DE(p)<0)
                            DE(p) = -x;
                        else
                            DE(p)=(DE(p)-x)/2;
                        end
                    end
                    for i=1:ceil((n+6)/3)-ceil((n+4)/3)
                        tline = fgetl(fid);
                    end
                end
            else
                disp('cannot find delay power partial result');
            end
            fclose(fid);
    end
    
    if(min(DE)>0&&min(D)>0)
        f2=0;
    end
    
                
        



