% choose model for this stage
error_detect = 1;
for r_allocation = 1: length(devicemodel_allocation(:,1))
    if( length( find (devicemodel_allocation(r_allocation,:) == i_stage ) ) == 1 )
        subcktname = devicemodel(r_allocation).subcktname;
        error_detect = 0;
        break;
    end
end
if( error_detect)
    print('no model found for this bin stage');
    break;
end

fid=fopen(spname,'w');
fprintf(fid,'\n.inc ''%s'' \n',subcktname);
fprintf(fid,'.option converge=1\n');
fprintf(fid,'.param l=%d pulse=%4.4fn clock=%4.4fn cl=%d vd=%d vshift=%d rl=%d fanout=%3.2f ',L,Delay1*1e9*3,Delay1*2e9*3,C0,Xk(1),Xk(2),R,fanout-1);
for i=1:n
    fprintf(fid,'w%i=%d ',i,Xk(2+i));
end
fprintf(fid,'\n');

fprintf(fid,'.subckt inv1 1 2 3 w=1u\nXn1 7 4 0 0 ntype Wid_ps=''2*w'' Len_ps=l\nXn2 2 8 7 0 ntype Wid_ps=''2*w'' Len_ps=l\nXp1 2 9 3 3 ptype Wid_ps=w Len_ps=l\nXp2 2 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 vshift\nVtp 5 1 ''-vshift'' \nVtno 8 3 vshift \nVtpo 9 3 ''-vshift''\n.ends\n');
fprintf(fid,'.subckt inv2 1 2 3 w=1u\nXn 6 4 0 0 ntype Wid_ps=w Len_ps=l\nXp 6 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 vshift\nVtp 5 1 ''-vshift'' \nRl 6 2 rl\nCl 2 0 cl\n.ends\n');
 
 fprintf(fid,'xinv100 100 1 vdr inv2 w=w1\n');
 for i=1:1:n
     if(mod(i,2))
         fprintf(fid,'xinv%i %i %i vdd inv1 w=w%i\n',i,i,i+1,i);
     else
         fprintf(fid,'xinv%i %i %i vdd inv2 w=w%i\n',i,i,i+1,i);
         if(i<n)
             fprintf(fid,'xinv%i %i %i vdr inv1 w=''fanout*w%i''\n',100+i-1,i+1,200+i,i-1);
         else
             fprintf(fid,'xinv%i %i %i vdr inv1 w=''fanout*w%i+w%i''\n',100+i-1,i+1,200+i,i-1,i-1);
         end
     end
end


fprintf(fid,'Vdr vdr 0 DC vd\nVd vdd 0 DC vd\nVin 100 0 DC 0V\n');
fprintf(fid,'.DC sweep clock start=1n stop=2n step=1n\n');
fprintf(fid,'.option ingold=1 brief=1 \n');
fprintf(fid,'.print par''V(vdd)*I(Vd)'' \n');
fprintf(fid,'.end');
fclose(fid);
unix(hspicerun);

Leakage2=38;
fid=fopen(logname,'r');
f3=1;
while(~feof(fid))
    tline=fgetl(fid);
    [t r]=strtok(tline);
    if(strcmp(t,'v(vdd)*i(vd)'))
        tline=fgetl(fid);
            [t r]=strtok(tline);
            [t r]=strtok(r);
            [x status]=str2num(t);
            if(status~=0)
               Leakage2=x;
               f3=0;
            end
            
            break;
    end
end
fclose(fid);


fid=fopen(spname,'w');
fprintf(fid,'\n.inc ''%s'' \n',subcktname);
fprintf(fid,'.option converge=1\n');
fprintf(fid,'.param l=%d pulse=%4.4fn clock=%4.4fn cl=%d vd=%d vshift=%d rl=%d fanout=%3.2f ',L,Delay1*1e9*3,Delay1*2e9*3,C0,Xk(1),Xk(2),R,fanout-1);
for i=1:n
    fprintf(fid,'w%i=%d ',i,Xk(2+i));
end
fprintf(fid,'\n');

fprintf(fid,'.subckt inv1 1 2 3 w=1u\nXn1 7 4 0 0 ntype Wid_ps=''2*w'' Len_ps=l\nXn2 2 8 7 0 ntype Wid_ps=''2*w'' Len_ps=l\nXp1 2 9 3 3 ptype Wid_ps=w Len_ps=l\nXp2 2 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 vshift\nVtp 5 1 ''-vshift'' \nVtno 8 3 vshift \nVtpo 9 3 ''-vshift''\n.ends\n');
fprintf(fid,'.subckt inv2 1 2 3 w=1u\nXn 6 4 0 0 ntype Wid_ps=w Len_ps=l\nXp 6 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 vshift\nVtp 5 1 ''-vshift'' \nRl 6 2 rl\nCl 2 0 cl\n.ends\n');
 
 fprintf(fid,'xinv100 100 1 vdr inv2 w=w1\n');
 for i=1:1:n
     if(mod(i,2))
         fprintf(fid,'xinv%i %i %i vdd inv1 w=w%i\n',i,i,i+1,i);
     else
         fprintf(fid,'xinv%i %i %i vdd inv2 w=w%i\n',i,i,i+1,i);
         if(i<n)
             fprintf(fid,'xinv%i %i %i vdr inv1 w=''fanout*w%i''\n',100+i-1,i+1,200+i,i-1);
         else
             fprintf(fid,'xinv%i %i %i vdr inv1 w=''fanout*w%i+w%i''\n',100+i-1,i+1,200+i,i-1,i-1);
         end
     end
 end

if(flag_var)
    fprintf(fid,'.subckt inv1_s 1 2 3 dvt=0 w=1u\nXn1 7 4 0 0 ntype Wid_ps=''2*w'' Len_ps=l\nXn2 2 8 7 0 ntype Wid_ps=''2*w'' Len_ps=l\nXp1 2 9 3 3 ptype Wid_ps=w Len_ps=l\nXp2 2 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 ''dvt+vshift''\nVtp 5 1 ''-dvt-vshift'' \nVtno 8 3 ''dvt+vshift'' \nVtpo 9 3 ''-dvt-vshift''\n.ends\n');
    fprintf(fid,'.subckt inv2_s 1 2 3 dvt=0 w=1u\nXn 6 4 0 0 ntype Wid_ps=w Len_ps=l\nXp 6 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 ''dvt+vshift''\nVtp 5 1 ''-dvt-vshift'' \nRl 6 2 rl\nCl 2 0 cl\n.ends\n');

    fprintf(fid,'xinv100_s 100_s 1_s vdr_s inv2_s w=''w1-%4.4f'' dvt=%3.3f\n',dw1,dvt);
    for i=1:1:n
     if(mod(i,2))
         fprintf(fid,'xinv%i_s %i_s %i_s vdd_s inv1_s w=''w%i-%4.4f'' dvt=%3.3f\n',i,i,i+1,i,dw1,dvt);
     else
         fprintf(fid,'xinv%i_s %i_s %i_s vdd_s inv2_s w=''w%i-%4.4f'' dvt=%3.3f\n',i,i,i+1,i,dw1,dvt);
         if(i<n)
             fprintf(fid,'xinv%i_s %i_s %i_s vdr_s inv1_s w=''fanout*w%i-fanout*%4.4f'' dvt=%3.3f\n',100+i-1,i+1,200+i,i-1,dw1,dvt);
         else
             fprintf(fid,'xinv%i_s %i_s %i_S vdr_s inv1_s w=''fanout*w%i+w%i-%4.4f-fanout*%4.4f'' dvt=%3.3f\n',100+i-1,i+1,200+i,i-1,i-1,dw1,dw1,dvt);
         end
         
     end
    end
    fprintf(fid,'Vdr_s vdr_s 0 DC=''vd*%2.2f''\nVd_s vdd_s 0 DC=''vd*%2.2f''\nVpulse_s 100_s 0 PULSE(0,''vd*%2.2f'',10n,10p,10p,''clock/2'',clock)\n',p_slow,p_slow,p_slow);
end

fprintf(fid,'Vdr vdr 0 DC vd\nVd vdd 0 DC vd\nVpulse 100 0 PULSE(0,vd,10n,10p,10p,pulse,clock)\n.tran ''clock/1000'' ''clock*3+10n'' \n');
if(flag_var)
    fprintf(fid,'.measure tran t1 trig V(1_s) val=''%2.2f*vd/2'' TD=''10n+clock/4'' rise=2 targ V(%i_s) val=''%2.2f*vd/2'' TD=''10n+clock/4'' %s=2\n',p_slow,n+1,p_slow,edge);
else
    fprintf(fid,'.measure tran t1 trig V(1) val=''vd/2'' TD=''10n+clock/4'' rise=2 targ V(%i) val=''vd/2'' TD=''10n+clock/4'' %s=2\n',n+1,edge);
end

fprintf(fid,'\n.measure tran avgpower avg par''p(Vd)+p(Vpulse)'' FROM=''clock*0.3+10n'' TO=''clock*2.3+10n''\n');
fprintf(fid,'.measure tran leakpower avg par''p(Vd)+p(Vpulse)'' FROM=''clock*1.3+10n+10p'' TO=''clock*1.4+10n+10p''\n');
fprintf(fid,'.ic ');
fprintf(fid,'v(100)=0 ');
for i=1:n
    if(mod(i,2)==0)
        fprintf(fid,'v(%i)=0 ',i);
    else
        fprintf(fid,'v(%i)=''vd'' ',i);
    end
end
if(flag_var)
    fprintf(fid,'v(100_s)=0 ');
for i=1:n
    if(mod(i,2)==0)
        fprintf(fid,'v(%i_s)=0 ',i);
    else
        fprintf(fid,'v(%i_s)=''vd*%2.2f'' ',i,p_slow);
    end
end
end
fprintf(fid,'\n');
fprintf(fid,'.end');
fclose(fid);
unix(hspicerun);

fid=fopen(resultname, 'r');
if (fid ~= -1)
    x = [];
    for (j=1:5)
        tline=fgetl(fid);
    end
    [t r] = strtok(tline);
    if(~ischar(t))
        f4=1;
        Delay2=38;
    else
        [Delay2,status]=str2num(t);
    end
    if(status==0)
        f4=1;
        Delay2=38;
    end
    if(Delay2<=0)
        f4=1;
    end
    
    [t r] = strtok(r);
    if(~ischar(t))
        f4=1;
    else
        [Energy2,status]=str2num(t);
    end
    if(status==0)
        f4=1;
        Energy2=38;
    end
%     [t r] = strtok(r);
%     if(~ischar(t))
%         f4=1;
%     else
%         [Leakage2,status]=str2num(t);
%     end
%     if(status==0)
%         f4=1;     
%     end                
%     if( (Delay1/Delay2)>2.5 || (Delay2/Delay1)>2.5)
%         f4=1;
%         delay1ne2=['delay1 and delay2 have big difference delay1=',num2str(Delay1),' delay2=',num2str(Delay2)];
%         disp(delay1ne2);
%     end
            
    if(Energy2>=0  || Energy2>Leakage2/2)
        f4=1;
        disp('energy2 >=0 or energy2 < leakage');
        disp(Energy2);
        disp(Leakage2);
    else
        if(Energy2>Leakage2)
            Energy2=Leakage2;
        end
    end
else
    f4=1;
end
fclose(fid);




if(f4==1)
    f4=0;
    fid=fopen(spname,'w');
fprintf(fid,'\n.inc ''%s'' \n',subcktname);
fprintf(fid,'.option converge=3\n');
fprintf(fid,'.param l=%d pulse=%4.4fn clock=%4.4fn cl=%d vd=%d vshift=%d rl=%d fanout=%3.2f ',L,Delay1*1e9*3,Delay1*2e9*3,C0,Xk(1),Xk(2),R,fanout-1);
for i=1:n
    fprintf(fid,'w%i=%d ',i,Xk(2+i));
end
fprintf(fid,'\n');

fprintf(fid,'.subckt inv1 1 2 3 w=1u\nXn1 7 4 0 0 ntype Wid_ps=''2*w'' Len_ps=l\nXn2 2 8 7 0 ntype Wid_ps=''2*w'' Len_ps=l\nXp1 2 9 3 3 ptype Wid_ps=w Len_ps=l\nXp2 2 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 vshift\nVtp 5 1 ''-vshift'' \nVtno 8 3 vshift \nVtpo 9 3 ''-vshift''\n.ends\n');
fprintf(fid,'.subckt inv2 1 2 3 w=1u\nXn 6 4 0 0 ntype Wid_ps=w Len_ps=l\nXp 6 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 vshift\nVtp 5 1 ''-vshift'' \nRl 6 2 rl\nCl 2 0 cl\n.ends\n');
 
 fprintf(fid,'xinv100 100 1 vdr inv2 w=w1\n');
 for i=1:1:n
     if(mod(i,2))
         fprintf(fid,'xinv%i %i %i vdd inv1 w=w%i\n',i,i,i+1,i);
     else
         fprintf(fid,'xinv%i %i %i vdd inv2 w=w%i\n',i,i,i+1,i);
         if(i<n)
             fprintf(fid,'xinv%i %i %i vdr inv1 w=''fanout*w%i''\n',100+i-1,i+1,200+i,i-1);
         else
             fprintf(fid,'xinv%i %i %i vdr inv1 w=''fanout*w%i+w%i''\n',100+i-1,i+1,200+i,i-1,i-1);
         end
     end
end


fprintf(fid,'Vdr vdr 0 DC vd\nVd vdd 0 DC vd\nVin 100 0 DC 0V\n');
fprintf(fid,'.DC sweep clock start=1n stop=2n step=1n\n');
fprintf(fid,'.option ingold=1 brief=1 \n');
fprintf(fid,'.print par''V(vdd)*I(Vd)'' \n');
fprintf(fid,'.end');
fclose(fid);
unix(hspicerun);

Leakage2=38;
fid=fopen(logname,'r');
f3=1;
while(~feof(fid))
    tline=fgetl(fid);
    [t r]=strtok(tline);
    if(strcmp(t,'v(vdd)*i(vd)'))
        tline=fgetl(fid);
            [t r]=strtok(tline);
            [t r]=strtok(r);
            [x status]=str2num(t);
            if(status==0)
                x=-1;
            end
            Leakage2=x;
            break;
    end
end
fclose(fid);


fid=fopen(spname,'w');
fprintf(fid,'\n.inc ''%s'' \n',subcktname);
fprintf(fid,'.option converge=3\n');
fprintf(fid,'.param l=%d pulse=%4.4fn clock=%4.4fn cl=%d vd=%d vshift=%d rl=%d fanout=%3.2f ',L,Delay1*1e9*3,Delay1*2e9*3,C0,Xk(1),Xk(2),R,fanout-1);
for i=1:n
    fprintf(fid,'w%i=%d ',i,Xk(2+i));
end
fprintf(fid,'\n');

fprintf(fid,'.subckt inv1 1 2 3 w=1u\nXn1 7 4 0 0 ntype Wid_ps=''2*w'' Len_ps=l\nXn2 2 8 7 0 ntype Wid_ps=''2*w'' Len_ps=l\nXp1 2 9 3 3 ptype Wid_ps=w Len_ps=l\nXp2 2 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 vshift\nVtp 5 1 ''-vshift'' \nVtno 8 3 vshift \nVtpo 9 3 ''-vshift''\n.ends\n');
fprintf(fid,'.subckt inv2 1 2 3 w=1u\nXn 6 4 0 0 ntype Wid_ps=w Len_ps=l\nXp 6 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 vshift\nVtp 5 1 ''-vshift'' \nRl 6 2 rl\nCl 2 0 cl\n.ends\n');
 
 fprintf(fid,'xinv100 100 1 vdr inv2 w=w1\n');
 for i=1:1:n
     if(mod(i,2))
         fprintf(fid,'xinv%i %i %i vdd inv1 w=w%i\n',i,i,i+1,i);
     else
         fprintf(fid,'xinv%i %i %i vdd inv2 w=w%i\n',i,i,i+1,i);
         if(i<n)
             fprintf(fid,'xinv%i %i %i vdr inv1 w=''fanout*w%i''\n',100+i-1,i+1,200+i,i-1);
         else
             fprintf(fid,'xinv%i %i %i vdr inv1 w=''fanout*w%i+w%i''\n',100+i-1,i+1,200+i,i-1,i-1);
         end
     end
 end

if(flag_var)
    fprintf(fid,'.subckt inv1_s 1 2 3 dvt=0 w=1u\nXn1 7 4 0 0 ntype Wid_ps=''2*w'' Len_ps=l\nXn2 2 8 7 0 ntype Wid_ps=''2*w'' Len_ps=l\nXp1 2 9 3 3 ptype Wid_ps=w Len_ps=l\nXp2 2 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 ''dvt+vshift''\nVtp 5 1 ''-dvt-vshift'' \nVtno 8 3 ''dvt+vshift'' \nVtpo 9 3 ''-dvt-vshift''\n.ends\n');
    fprintf(fid,'.subckt inv2_s 1 2 3 dvt=0 w=1u\nXn 6 4 0 0 ntype Wid_ps=w Len_ps=l\nXp 6 5 3 3 ptype Wid_ps=w Len_ps=l\nVtn 4 1 ''dvt+vshift''\nVtp 5 1 ''-dvt-vshift'' \nRl 6 2 rl\nCl 2 0 cl\n.ends\n');

    fprintf(fid,'xinv100_s 100_s 1_s vdr_s inv2_s w=''w1-%4.4f'' dvt=%3.3f\n',dw1,dvt);
    for i=1:1:n
     if(mod(i,2))
         fprintf(fid,'xinv%i_s %i_s %i_s vdd_s inv1_s w=''w%i-%4.4f'' dvt=%3.3f\n',i,i,i+1,i,dw1,dvt);
     else
         fprintf(fid,'xinv%i_s %i_s %i_s vdd_s inv2_s w=''w%i-%4.4f'' dvt=%3.3f\n',i,i,i+1,i,dw1,dvt);
         if(i<n)
             fprintf(fid,'xinv%i_s %i_s %i_s vdr_s inv1_s w=''fanout*w%i-fanout*%4.4f'' dvt=%3.3f\n',100+i-1,i+1,200+i,i-1,dw1,dvt);
         else
             fprintf(fid,'xinv%i_s %i_s %i_S vdr_s inv1_s w=''fanout*w%i+w%i-%4.4f-fanout*%4.4f'' dvt=%3.3f\n',100+i-1,i+1,200+i,i-1,i-1,dw1,dw1,dvt);
         end
         
     end
    end
    fprintf(fid,'Vdr_s vdr_s 0 DC=''vd*%2.2f''\nVd_s vdd_s 0 DC=''vd*%2.2f''\nVpulse_s 100_s 0 PULSE(0,''vd*%2.2f'',10n,10p,10p,''clock/2'',clock)\n',p_slow,p_slow,p_slow);
end 

fprintf(fid,'Vdr vdr 0 DC vd\nVd vdd 0 DC vd\nVpulse 100 0 PULSE(0,vd,10n,10p,10p,pulse,clock)\n.tran ''clock/1000'' ''clock*3+10n'' \n');
if(flag_var)
    fprintf(fid,'.measure tran t1 trig V(1_s) val=''%2.2f*vd/2'' TD=''10n+clock/4'' rise=2 targ V(%i_s) val=''%2.2f*vd/2'' TD=''10n+clock/4'' %s=2\n',p_slow,n+1,p_slow,edge);
else
    fprintf(fid,'.measure tran t1 trig V(1) val=''vd/2'' TD=''10n+clock/4'' rise=2 targ V(%i) val=''vd/2'' TD=''10n+clock/4'' %s=2\n',n+1,edge);
end
fprintf(fid,'\n.measure tran avgpower avg par''p(Vd)+p(Vpulse)'' FROM=''clock*0.3+10n'' TO=''clock*2.3+10n''\n');
fprintf(fid,'.measure tran leakpower avg par''p(Vd)+p(Vpulse)'' FROM=''clock*1.3+10n+10p'' TO=''clock*1.4+10n+10p''\n');
fprintf(fid,'.ic ');
fprintf(fid,'v(100)=0 ');
for i=1:n
    if(mod(i,2)==0)
        fprintf(fid,'v(%i)=0 ',i);
    else
        fprintf(fid,'v(%i)=''vd'' ',i);
    end
end
if(flag_var)
    fprintf(fid,'v(100_s)=0 ');
for i=1:n
    if(mod(i,2)==0)
        fprintf(fid,'v(%i_s)=0 ',i);
    else
        fprintf(fid,'v(%i_s)=''vd*%2.2f'' ',i,p_slow);
    end
end
end
fprintf(fid,'\n');
fprintf(fid,'.end');
fclose(fid);
unix(hspicerun);

fid=fopen(resultname, 'r');
if (fid ~= -1)
    x = [];
    for (j=1:5)
        tline=fgetl(fid);
    end
    [t r] = strtok(tline);
    if(~ischar(t))
        f4=1;
        Delay2=38;
    else
        [Delay2,status]=str2num(t);
    end
    if(status==0)
        f4=1;
        Delay2=38;
    end
    if(Delay2<=0)
        f4=1;
    end
    
    [t r] = strtok(r);
    if(~ischar(t))
        f4=1;
    else
        [Energy2,status]=str2num(t);
    end
    if(status==0)
        f4=1;
        Energy2=38;
    end
%     [t r] = strtok(r);
%     if(~ischar(t))
%         f4=1;
%     else
%         [Leakage2,status]=str2num(t);
%     end
%     if(status==0)
%         f4=1;     
%     end                
%     if( (Delay1/Delay2)>2.5 || (Delay2/Delay1)>2.5)
%         f4=1;
%         delay1ne2=['delay1 and delay2 have big difference delay1=',num2str(Delay1),' delay2=',num2str(Delay2)];
%         disp(delay1ne2);
%     end
            
    if(Energy2>=0  || Energy2>Leakage2/2)
        f4=1;
        disp('energy2 >=0 or energy2 < leakage');
        disp(Energy2);
        disp(Leakage2);
    else
        if(Energy2>Leakage2)
            Energy2=Leakage2;
        end
    end
else
    f4=1;
end
fclose(fid);
end
Energy2=(-Energy2+Leakage2)*6*Delay1/2*activity;   
